import React, { Component } from "react";
import "./App.css";

import Children from "./childrenComp";

export default class App extends Component {
	constructor(props) {
		super(props);
		this.state = {
			value: "",
			editEvalue: "",
			date: new Date(),
			list: []
		};
		console.log("constructor");
	}

	tick = () => this.setState({ date: new Date() });

	componentWillMount() {
		console.log("componentWillMount");
	}

	componentDidMount() {
		console.log("componentDidMount APP");
		this.timerID = setInterval(() => this.tick(), 1000);
	}

	componentWillUnmount() {
		clearInterval(this.timerID);
	}

	// addToArr() {
	// 	console.log("Do smth here");
	// }

	addToArr = () => {
		const { value, editEvalue } = this.state;

		if (editEvalue) {
			return this.setState(prevState => ({
				list: prevState.list.map(el => (el === editEvalue ? value : el)),
				value: "",
				editEvalue: ""
			}));
		}

		return this.setState(prevState => ({ list: prevState.list.concat(value), value: "", editEvalue: "" }));
		// this.setState(prevState => ({ list: [...prevState.list, value] }))
	};

	setValue = e => {
		const { value } = e.target;

		this.setState({ value });
	};

	delete = (e, item) => {
		e.preventDefault();
		this.setState(prevState => ({
			list: prevState.list.filter(el => el !== item)
		}));
	};

	editValue = item => {
		this.setState({ editEvalue: item, value: item });
	};

	render() {
		const { value, list } = this.state;

		return (
			<div className="App">
				<input type="text" value={value} onChange={this.setValue} />
				{<Children date={this.state.date.toLocaleTimeString()} />}
				<button onClick={this.addToArr}>Add</button>
				<ul>
					{list.map((el, i) => (
						<li key={i} onClick={this.editValue.bind(null, el)}>
							{el} <button onClick={e => this.delete(e, el)}>x</button>
						</li>
					))}
				</ul>
			</div>
		);
	}
}
